//+------------------------------------------------------------------+
//|                                                      FIboPiv.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
//Thanks to Kalenzo bartlomiej.gorski@gmail.com

#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 ForestGreen
#property indicator_style1 STYLE_DOT
#property indicator_color2 ForestGreen
#property indicator_style2 STYLE_DOT
#property indicator_color3 ForestGreen
#property indicator_style3 STYLE_DOT
#property indicator_color4 Goldenrod
#property indicator_style4 STYLE_DOT
#property indicator_color5 Sienna
#property indicator_style5 STYLE_DOT
#property indicator_color6 Sienna
#property indicator_style6 STYLE_DOT
#property indicator_color7 Sienna
#property indicator_style7 STYLE_DOT

extern int MaxBars = 300;

//---- buffers
double R3[];
double R2[];
double R1[];
double Pivot[];
double S1[];
double S2[];
double S3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,R3);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,R2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,R1);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,Pivot);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,S1);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,S2);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,S3);
//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	int counted_bars = IndicatorCounted();
	
	double rates[][6];
	ArrayCopyRates(rates, Symbol(), PERIOD_D1);
	double yesterday_high, yesterday_low, yesterday_close;
	int d;
	for(int i= 0; i< Bars - counted_bars; i++)
	{		
		if(i > MaxBars) break;
		for(int j = 0; j < ArrayRange(rates, 0); j++)
		{
			//if(rates[j][0] == Date(Time[i]))
			if(TimeToStr(rates[j][0], TIME_DATE) == TimeToStr(Time[i], TIME_DATE))
			{
				d = j + 1;
				break;
			}
		}
		if(TimeDayOfWeek(rates[d-1][0]) == 1)
		{
			yesterday_close = rates[d][4];
			if(rates[d+1][3] > rates[d][3]) yesterday_high = rates[d+1][3]; else yesterday_high = rates[d][3];
			if(rates[d+1][2] < rates[d][2]) yesterday_low = rates[d+1][2]; else yesterday_low = rates[d][2];
		}
		else
		{
			yesterday_high = rates[d][3];
			yesterday_low = rates[d][2];
			yesterday_close = rates[d][4];
		}
		double range = yesterday_high - yesterday_low;

		Pivot[i] = (yesterday_high + yesterday_low + yesterday_close) / 3;
		//Pivot[i] = yesterday_close;
		R3[i] = Pivot[i] + (range * 1.000);
		R2[i] = Pivot[i] + (range * 0.618);
		R1[i] = Pivot[i] + (range * 0.382);
		S1[i] = Pivot[i] - (range * 0.382);
		S2[i] = Pivot[i] - (range * 0.618);
		S3[i] = Pivot[i] - (range * 1.000);
	}
	
	return(0);
}
//+------------------------------------------------------------------+



